# remirepo/Fedora spec file for php-zendframework-zend-i18n
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    6d69af5a04e1a4de7250043cb1322f077a0cdb7f
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-i18n
%global php_home     %{_datadir}/php
%global library      I18n
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.9.0
Release:        4%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-ctype
BuildRequires:  php-date
BuildRequires:  php-intl
BuildRequires:  php-pcre
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.2",
#        "zendframework/zend-cache": "^2.6.1",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-config": "^2.6",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-filter": "^2.6.1",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-validator": "^2.6",
#        "zendframework/zend-view": "^2.6.3"
BuildRequires:  (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)         <  4)
BuildRequires:  (php-composer(%{gh_owner}/zend-cache)            >= 2.6.1 with php-composer(%{gh_owner}/zend-cache)            <  3)
BuildRequires:  (php-composer(%{gh_owner}/zend-config)           >= 2.6   with php-composer(%{gh_owner}/zend-config)           <  3)
BuildRequires:  (php-composer(%{gh_owner}/zend-eventmanager)     >= 2.6.2 with php-composer(%{gh_owner}/zend-eventmanager)     <  4)
BuildRequires:  (php-composer(%{gh_owner}/zend-filter)           >= 2.5   with php-composer(%{gh_owner}/zend-filter)           <  3)
BuildRequires:  (php-composer(%{gh_owner}/zend-servicemanager)   >= 2.7.5 with php-composer(%{gh_owner}/zend-servicemanager)   <  4)
BuildRequires:  (php-composer(%{gh_owner}/zend-validator)        >= 2.6   with php-composer(%{gh_owner}/zend-validator)        <  3)
BuildRequires:  (php-composer(%{gh_owner}/zend-view)             >= 2.6.3 with php-composer(%{gh_owner}/zend-view)             <  3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.2
# Autoloader
BuildRequires:  php-composer(%{gh_owner}/zend-loader)           >= 2.5
%endif
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
Requires:       (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)         <  4)
# From composer, "suggest": {
#        "ext-intl": "Required for most features of Zend\\I18n; included in default builds of PHP",
#        "zendframework/zend-cache": "Zend\\Cache component",
#        "zendframework/zend-config": "Zend\\Config component",
#        "zendframework/zend-eventmanager": "You should install this package to use the events in the translator",
#        "zendframework/zend-filter": "You should install this package to use the provided filters",
#        "zendframework/zend-i18n-resources": "Translation resources",
#        "zendframework/zend-servicemanager": "Zend\\ServiceManager component",
#        "zendframework/zend-validator": "You should install this package to use the provided validators",
#        "zendframework/zend-view": "You should install this package to use the provided view helpers",
#        "zendframework/zend-resources": "Translation resources"
Suggests:       php-composer(%{gh_owner}/zend-cache)
Suggests:       php-composer(%{gh_owner}/zend-config)
Suggests:       php-composer(%{gh_owner}/zend-eventmanager)
Suggests:       php-composer(%{gh_owner}/zend-filter)
Suggests:       php-composer(%{gh_owner}/zend-i18n-resources)
Suggests:       php-composer(%{gh_owner}/zend-servicemanager)
Suggests:       php-composer(%{gh_owner}/zend-validator)
Suggests:       php-composer(%{gh_owner}/zend-view)
%endif
Requires:       php-intl
# From phpcompatinfo report for version 2.5.1
Requires:       php-ctype
Requires:       php-date
Requires:       php-pcre
Requires:       php-spl
# Autoloader
Requires:       php-composer(fedora/autoloader)

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\I18n comes with a complete translation suite which supports all major
formats and includes popular features like plural translations and text
domains. The Translator component is mostly dependency free, except for
the fallback to a default locale, where it relies on the Intl PHP extension.

The translator itself is initialized without any parameters, as any
configuration to it is optional. A translator without any translations
will actually do nothing but just return the given message IDs.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Cache/autoload.php',
    '%{php_home}/Zend/Config/autoload.php',
    '%{php_home}/Zend/EventManager/autoload.php',
    '%{php_home}/Zend/Filter/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
    '%{php_home}/Zend/View/autoload.php',
    '%{php_home}/Zend/I18n/Translator/Resources.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
# For BR without new autoloader
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} \
%if 0%{?fedora} >= 29
      --filter '^((?!(testSettersProvideDefaults|testBasic)).)*$' \
%endif
      --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.9.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.9.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed May 23 2018 Remi Collet <remi@remirepo.net> - 2.9.0-2
- update to 2.9.0
- skip test failing with libicu 61, reported as
  https://github.com/zendframework/zend-i18n/issues/97

* Thu Apr 26 2018 Remi Collet <remi@remirepo.net> - 2.8.0-2
- update to 2.8.0
- switch to phpunit7
- use range dependencies

* Tue Feb 13 2018 Remi Collet <remi@remirepo.net> - 2.7.4-4
- fix FTBFS from Koschei, path from
  https://github.com/zendframework/zend-i18n/pull/91
- always use phpunit6

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Fri Nov 24 2017 Remi Collet <remi@remirepo.net> - 2.7.4-3
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.7.4-1
- Update to 2.7.4
- raise dependency on PHP 5.6
- use phpunit6 on F26+

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Jun 10 2016 Remi Collet <remi@fedoraproject.org> - 2.7.3-1
- update to 2.7.3

* Tue Apr 19 2016 Remi Collet <remi@fedoraproject.org> - 2.7.2-1
- update to 2.7.2

* Thu Mar 31 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Fri Feb 12 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on PHP >= 5.5
- raise dependency on zend-stdlib >= 2.7
- ignore failed test with ICU 56

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct  1 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- normal build

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-0
- initial package, bootstrap build
